#Module-Specific definitions
%define rversion 2.04_03
%define release 1mdk
%define mod_name mod_apreq
%define mod_conf 76_%{mod_name}.conf
%define mod_so %{mod_name}.so

#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}
%{expand:%%global ap_version %(%{apxs} -q ap_version)}

#Standard ADVX requires
Prereq:		%{ap_name} = %{ap_version}
Prereq:		%{ap_name}-conf
BuildPreReq:	ADVX-build >= 9.2
BuildRequires:	%{ap_name}-devel >= 2.0.48-4mdk
BuildRequires:	%{ap_name}-source >= 2.0.48-4mdk

%define	major 2
%define libname	%mklibname apreq %{major}

Summary:	Apache Request Library
Name:		%{libname}
Version:	%{rversion}
Release:	%{release}
License:	Apache License
Group:          System/Libraries
URL:		http://httpd.apache.org/apreq/
Source:		libapreq2-%{rversion}-dev.tar.bz2
Source1:	76_mod_apreq.conf.bz2
Patch0:		libapreq2-2.03-dev-version_check_fix.diff.bz2
BuildRequires:	autoconf2.5
BuildRequires:	automake1.7
BuildRequires:	chrpath
BuildRequires:	perl-devel
BuildRequires:	perl-Tie-IxHash
BuildRequires:	perl-ExtUtils-XSBuilder
BuildRequires:	%{ap_name}-mod_perl-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}

%description
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

This package contains the shared libraries for %{name}

%package -n	%{libname}-devel
Summary:	Development library and header files for the Apache Request Library
Version:	%{rversion}
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	libapreq-devel

%description -n	%{libname}-devel
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

This package contains the development library and its header files.

%package -n	perl-libapreq2
Summary:	Apache Request Library Perl Glue
Version:	%{rversion}
Group:		System/Servers
Requires:	%{ap_name}-mod_perl

%description -n perl-libapreq2
libapreq is a safe, standards-compliant, high-performance library used for
parsing HTTP cookies, query-strings and POST data. The original version
(libapreq-1.X) was designed by Lincoln Stein and Doug MacEachern. The perl
APIs Apache::Request and Apache::Cookie are the lightweight mod_perl analogs of
the CGI and CGI::Cookie perl modules.

%package -n	%{ap_name}-%{mod_name}
Summary:	Mod_%{rname} is a DSO module for the %{ap_name} Web server.
Version:	%{ap_version}_%{rversion}
Group:		System/Servers
Requires:	%{ap_name} = %{ap_version}
Requires:	%{ap_name}-conf
Requires:	perl-libapreq2 = %{rversion}

%description -n	%{ap_name}-%{mod_name}
Mod_%{name} is a DSO module for the %{ap_name} Web server.

%prep

%setup -q -n libapreq2-2.04-dev
%patch0 -p0

# got the idea why this wasn't working from debian, thanks guys!
# P0 combined with this hack fixes it all...
perl -pi -e "s|_APACHE2_REAL_VERSION_|%{ap_version}|g" build/version_check.pl

bzcat %{SOURCE1} > %{mod_conf}

%build
export WANT_AUTOCONF_2_5=1
libtoolize --copy --force; aclocal-1.7; autoconf; automake-1.7 --add-missing

%configure2_5x \
    --with-apache2-apxs=%{apxs}

# hose the Makefile to not run apxs
grep -v -e 'apxs.*mod_apreq\.la' env/Makefile > env/Makefile.hosed
mv -f env/Makefile.hosed env/Makefile
%make

# Build the perl modules
pushd glue/perl
    %{__perl} ../../build/xsbuilder.pl run
    CFLAGS="%{optflags}" %{__perl} Makefile.PL -apxs %{apxs} INSTALLDIRS=vendor
    %make
    mv Makefile Makefile.xx
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%makeinstall_std

# install the module
install -d %{buildroot}%{ap_libexecdir}
install -d %{buildroot}%{ap_extralibs}
libtool --mode=install install env/mod_apreq.la %{buildroot}%{ap_libexecdir}/
mv %{buildroot}%{ap_libexecdir}/%{mod_so} %{buildroot}%{ap_extralibs}/

# install module conf files for the "conf.d" dir loading structure
install -d %{buildroot}%{ap_confd}
install -m0640 %{mod_conf} %{buildroot}%{ap_confd}/

# install one extra devel file
install -m0755 apreq*-config %{buildroot}%{_bindir}/

# install the perl stuff
pushd glue/perl
cp Makefile.xx Makefile
%makeinstall_std
popd

# nuke rpath
chrpath -d %{buildroot}%{perl_vendorlib}/*/Apache2/auto/Apache/Cookie/Cookie.so
chrpath -d %{buildroot}%{perl_vendorlib}/*/Apache2/auto/Apache/Request/Request.so
chrpath -d %{buildroot}%{perl_vendorlib}/*/Apache2/auto/Apache/Upload/Upload.so

# fix docs
rm -rf html
cp -rp docs/html .
rm html/installdox
chmod 644 html/*

# install man files
install -d %{buildroot}%{_mandir}/man3
install -m0644 docs/man/man3/* %{buildroot}%{_mandir}/man3/

# cleanup
rm -rf %{buildroot}%{ap_libexecdir}

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%post -n %{ap_name}-%{mod_name}
%ADVXpost

%postun -n %{ap_name}-%{mod_name}
%ADVXpost

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root)
%doc CHANGES INSTALL MANIFEST PREREQUISITES README
%{_libdir}/libapreq*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc CHANGES INSTALL MANIFEST PREREQUISITES README html
%{_bindir}/apreq*-config
%{_libdir}/libapreq*.so
%{_libdir}/libapreq*.la
%{_libdir}/libapreq*.a
%{_includedir}/apreq*

%files -n %{ap_name}-%{mod_name}
%defattr(-,root,root)
%doc CHANGES INSTALL MANIFEST PREREQUISITES README
%config(noreplace) %{ap_confd}/%{mod_conf}
%{ap_extralibs}/%{mod_so}

%files -n perl-libapreq2
%defattr(-,root,root)
%doc CHANGES INSTALL MANIFEST PREREQUISITES README
%{perl_vendorlib}/*/Apache2/auto/Apache/Cookie
%{perl_vendorlib}/*/Apache2/auto/Apache/Request
%{perl_vendorlib}/*/Apache2/auto/Apache/Upload
%{perl_vendorlib}/*/Apache2/Apache/*
%{_mandir}/man3/*

%changelog
* Fri Sep 03 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.04_03-1mdk
- 2.04_03

* Tue Aug 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.03_04-3mdk
- rebuilt

* Sun Aug 01 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.03_04-2mdk
- rebuilt for apache 2.0.50

* Mon Jun 21 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.03_04-1mdk
- initial mandrake package based on the spec file by Bojan Smojver
